"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
exports.Storage = void 0;
var value_1 = require("../value");
var utils_1 = require("../utils");
var iterators_1 = require("../iterators");
/**
 * Key-value storage.
 */
var Storage = /** @class */ (function (_super) {
    __extends(Storage, _super);
    function Storage(params, parentPaths) {
        if (params === void 0) { params = utils_1.EMPTY_OBJECT; }
        if (parentPaths === void 0) { parentPaths = iterators_1.EMPTY_ITERABLE; }
        var _this = _super.call(this) || this;
        _this.params = params;
        _this.parentPaths = parentPaths;
        _this.destroyed = false;
        if (_this.params.onCreateStorage != null)
            _this.params.onCreateStorage(_this);
        return _this;
    }
    /**
     * Calls a `destroy` implementation that will unlink given storage from all entities
     * referencing it.
     *
     */
    Storage.prototype.destroy = function () {
        var _this = this;
        if (this.destroyed)
            return;
        this.destroyed = true;
        (0, iterators_1.forEach)(function (path) { return path.drop(_this); }, this.parentPaths);
        if (this.params.onRemoveStorage != null)
            this.params.onRemoveStorage(this);
    };
    /**
     * Returns `true` if supplied is weak, and thus won't be stored directly.
     * @param key
     */
    Storage.prototype.isWeak = function (_key) {
        return false;
    };
    /**
     * Returns `true` if value associated with the given key exists.
     * @param key
     *
     */
    Storage.prototype.has = function (key) {
        return this.get(key) !== value_1.NO_VALUE;
    };
    return Storage;
}(utils_1.HasLength));
exports.Storage = Storage;
//# sourceMappingURL=Storage.js.map