"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
exports.__esModule = true;
var memoize_1 = require("./memoize");
/**
 * Creates memoized selector. If last argument is an object, it will be treated as configuration.
 */
var createMemoizedSelector = function () {
    var _a, _b;
    var params = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        params[_i] = arguments[_i];
    }
    var paramsOrFunc = params.slice(-1)[0];
    var selectorFuncs = params.slice(0, -1);
    if (Array.isArray(selectorFuncs[0]))
        _a = selectorFuncs, _b = __read(_a, 1), selectorFuncs = _b[0];
    if (!params.length) {
        throw new Error("Must have at least one argument");
    }
    else if (params.length === 1) {
        if (typeof paramsOrFunc === "object")
            throw new Error("Structured selectors aren't currently supported");
    }
    else {
        selectorFuncs.forEach(function (param) {
            if (typeof param !== "function")
                throw new Error("Invalid type of param passed to memoization function: ".concat(param, " with type: ").concat(typeof param));
        });
    }
    var haveParams = typeof paramsOrFunc === "object";
    var calculate = haveParams ? params.slice(-2)[0] : paramsOrFunc;
    var memoized = (0, memoize_1["default"])(calculate, haveParams ? paramsOrFunc : void 0);
    function selector() {
        var length = selectorFuncs.length;
        var args = Array(length);
        while (length--)
            args[length] = selectorFuncs[length].apply(null, arguments);
        return memoized.apply(null, args);
    }
    selector.recomputations = function () { return memoized.recomputations; };
    selector.dependencies = selectorFuncs;
    selector.resultFunction = calculate;
    return selector;
};
exports["default"] = createMemoizedSelector;
//# sourceMappingURL=selector.js.map