"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
exports.__esModule = true;
exports.MapStorage = void 0;
var value_1 = require("../value");
var Storage_1 = require("../base/Storage");
var iterators_1 = require("../iterators");
/**
 * Key-value storage based on a `Map`.
 */
var MapStorage = /** @class */ (function (_super) {
    __extends(MapStorage, _super);
    function MapStorage(params, rootPath) {
        var _this = _super.call(this, params, rootPath) || this;
        _this.map = new Map();
        return _this;
    }
    /**
     * Returns amount of items stored in a map.
     *
     */
    MapStorage.prototype.len = function () {
        return this.map.size;
    };
    /**
     * Returns `true` if value associated with the given key exists.
     * @param key
     *
     */
    MapStorage.prototype.has = function (key) {
        return this.map.has(key);
    };
    /**
     * Retrieves an item corresponding to the supplied key.
     * @param key
     *
     */
    MapStorage.prototype.get = function (key) {
        if (this.map.has(key)) {
            return this.map.get(key);
        }
        else {
            return value_1.NO_VALUE;
        }
    };
    /**
     * Drops an item corresponding to the supplied key.
     * @param key
     *
     */
    MapStorage.prototype.drop = function (key) {
        var value = this.get(key);
        this.map["delete"](key);
        return value;
    };
    /**
     * Associates supplied item with the key.
     * @param key
     * @param value
     *
     */
    MapStorage.prototype.set = function (key, value) {
        this.map.set(key, value);
    };
    /**
     * Removes all items from the storage.
     *
     */
    MapStorage.prototype.clear = function () {
        this.map.clear();
    };
    /**
     * Returns an iterator over the entries.
     *
     */
    MapStorage.prototype.entries = function () {
        return (0, iterators_1.map)(function (_a) {
            var _b = __read(_a, 2), key = _b[0], value = _b[1];
            return ({ key: key, value: value });
        }, this.map.entries());
    };
    return MapStorage;
}(Storage_1.Storage));
exports.MapStorage = MapStorage;
//# sourceMappingURL=MapStorage.js.map