"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
exports.Noop = void 0;
var CacheStrategy_1 = require("../base/CacheStrategy");
var utils_1 = require("../utils");
var value_1 = require("../value");
/**
 * Placeholder cache replacement policy which is used when no limit is specified.
 */
var Noop = /** @class */ (function (_super) {
    __extends(Noop, _super);
    function Noop(capacity) {
        return _super.call(this, capacity) || this;
    }
    /**
     * Does nothing and always returns empty result.
     * @param value
     *
     */
    Noop.prototype.read = function (_) {
        return utils_1.Result.empty();
    };
    /**
     * Does nothing and always returns empty result.
     * @param value
     *
     */
    Noop.prototype.write = function (_) {
        return utils_1.Result.empty();
    };
    /**
     * Does nothing and always returns empty result.
     * @param node
     *
     */
    Noop.prototype.drop = function (_) {
        return false;
    };
    /**
     * Always returns zero.
     *
     */
    Noop.prototype.len = function () {
        return 0;
    };
    /**
     * Always returns `false`.
     * @param node
     *
     */
    Noop.prototype.has = function (_) {
        return false;
    };
    /**
     * Peeks a value from the beginning of the queue.
     * Always returns `NO_VALUE`.
     *
     */
    Noop.prototype.peek = function () {
        return value_1.NO_VALUE;
    };
    /**
     * Removes an item from the beginning of the queue.
     * Always returns `NO_VALUE`.
     *
     */
    Noop.prototype.take = function () {
        return value_1.NO_VALUE;
    };
    return Noop;
}(CacheStrategy_1.CacheStrategy));
exports.Noop = Noop;
//# sourceMappingURL=noop.js.map