"use strict";
exports.__esModule = true;
exports.isPrimitiveValue = exports.equals = exports.NO_VALUE = void 0;
/** Represents an absent value */
exports.NO_VALUE = {};
/** Checks given values to be equal according to the `Same-value-zero` equality algorithm */
var equals = function (v1, v2) {
    return v1 === v2 || (v2 !== v2 && v1 !== v1);
};
exports.equals = equals;
/**
 * Checks whether a value is primitive or not. Returns `true` if provided value is an object or a function.
 * @param value
 */
function isPrimitiveValue(value) {
    if (value == null) {
        return true;
    }
    else {
        var type = typeof value;
        return type !== "object" && type !== "function";
    }
}
exports.isPrimitiveValue = isPrimitiveValue;
//# sourceMappingURL=value.js.map